blob: 6ea3deb6e5e795a7bab016c584693f00291e8bf6 [file] [log] [blame]
Test User01ed0642019-07-03 20:17:06 +00001#!/bin/bash
David K. Bainbridgeb7285432019-07-02 22:05:24 -07002# Copyright 2019 Ciena Corporation
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
David Bainbridge712afb82019-08-14 19:55:58 +000015TOTAL_START_TIME=$(date +%s)
David K. Bainbridgeb7285432019-07-02 22:05:24 -070016
David Bainbridge38dc1e82019-08-12 15:18:45 +000017FANCY=${FANCY:-1}
18if [ "$TERM X" == " X" ]; then
19 FANCY=0
20fi
21
David K. Bainbridgeb7285432019-07-02 22:05:24 -070022# trap ctrl-c and call ctrl_c()
23trap ctrl_c INT
24
25function ctrl_c() {
David Bainbridge38dc1e82019-08-12 15:18:45 +000026 echo -en $CNORM
David K. Bainbridgeb7285432019-07-02 22:05:24 -070027 echo ""
28 echo "ctrl-c trapped"
David Bainbridgec6a6eb62019-10-18 22:50:07 +000029 echo "Thank you for trying 'voltha up'"
David K. Bainbridgeb7285432019-07-02 22:05:24 -070030 exit
31}
32
David K. Bainbridgeebf38d92020-02-10 10:46:31 -080033VOLTCTL_VERSION=${VOLTCTL_VERSION:-latest}
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -080034KIND_VERSION=${KIND_VERSION:-v0.5.1}
David K. Bainbridgeb3a99372020-01-08 14:39:06 -080035VK_RELEASE=${VK_RELEASE:-master}
Test User08ebbd92019-07-03 17:15:39 +000036
David Bainbridge38dc1e82019-08-12 15:18:45 +000037BLACK=
38RED=
39GREEN=
40YELLOW=
41BLUE=
42MAGENTA=
43CYAN=
44WHITE=
45BOLD=
46NORMAL=
47ERROR=
48CEOL=
49CNORM=
50CIVIS=
51if [ $FANCY -eq 1 ]; then
52 BLACK=$(tput setaf 0)
53 RED=$(tput setaf 1)
54 GREEN=$(tput setaf 2)
55 YELLOW=$(tput setaf 3)
56 BLUE=$(tput setaf 4)
57 MAGENTA=$(tput setaf 5)
58 CYAN=$(tput setaf 6)
59 WHITE=$(tput setaf 7)
60 BOLD=$(tput bold)
61 NORMAL=$(tput sgr0)
62 ERROR="\xe2\x9c\x97\x20"
63 CEOL=$(tput el)
64 CNORM=$(tput cnorm)
65 CIVIS=$(tput civis)
66fi
Test User7d866122019-07-09 17:52:35 +000067
Test User3d7ad8e2019-07-03 06:15:44 +000068TYPE=${TYPE:-minimal}
David Bainbridge0774b232019-08-02 06:37:19 +000069NAME=${NAME:-$TYPE}
David K. Bainbridge484d80c2020-03-05 21:44:34 -080070
71ENABLE_ONOS_EXTRANEOUS_RULES=${ENABLE_ONOS_EXTRANEOUS_RULES:-no}
David Bainbridgee87067b2019-08-12 22:00:12 +000072WITH_TIMINGS=${WITH_TIMINGS:-no}
Test User7d866122019-07-09 17:52:35 +000073WITH_BBSIM=${WITH_BBSIM:-no}
David Bainbridge5b7b96b2019-07-25 20:29:13 +000074WITH_RADIUS=${WITH_RADIUS:-no}
Matteo Scandolo78dfee02020-02-13 16:18:03 -080075WITH_EAPOL=${WITH_EAPOL:-yes}
76WITH_DHCP=${WITH_DHCP:-yes}
77WITH_IGMP=${WITH_IGMP:-no}
David Bainbridgeb270c202019-07-26 01:44:42 +000078WITH_ONOS=${WITH_ONOS:-yes}
David Bainbridge99ac7a22019-08-31 02:26:43 +000079WITH_CHAOS=${WITH_CHAOS:-no}
David Bainbridge46505fb2019-10-01 21:13:20 +000080WITH_ADAPTERS=${WITH_ADAPTERS:-yes}
81WITH_SIM_ADAPTERS=${WITH_SIM_ADAPTERS:-yes}
82WITH_OPEN_ADAPTERS=${WITH_OPEN_ADAPTERS:-yes}
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -080083WITH_PORT_FORWARDS=${WITH_PORT_FORWARDS:-yes}
David Bainbridge05cd8822019-11-19 17:43:53 +000084ONLY_ONE=${ONLY_ONE:-yes}
David Bainbridge2b19e832019-08-16 02:40:53 +000085CONFIG_SADIS=${CONFIG_SADIS:-no}
David Bainbridge27790d62019-08-13 22:43:19 +000086INSTALL_ONOS_APPS=${INSTALL_ONOS_APPS:-no}
Test Userba1e7e72019-07-10 22:27:54 +000087JUST_K8S=${JUST_K8S:-no}
88DEPLOY_K8S=${DEPLOY_K8S:-yes}
David K. Bainbridge0e89cb92019-07-17 11:30:10 -070089INSTALL_KUBECTL=${INSTALL_KUBECTL:-yes}
90INSTALL_HELM=${INSTALL_HELM:-yes}
David Bainbridge46505fb2019-10-01 21:13:20 +000091UPDATE_HELM_REPOS=${UPDATE_HELM_REPOS:-yes}
Matteo Scandolofab98622020-01-28 15:17:20 -080092WAIT_ON_DOWN=${WAIT_ON_DOWN:-yes}
David Bainbridge5b7b96b2019-07-25 20:29:13 +000093VOLTHA_LOG_LEVEL=${VOLTHA_LOG_LEVEL:-WARN}
David Bainbridge90fd8e32019-08-21 23:32:47 +000094VOLTHA_CHART=${VOLTHA_CHART:-onf/voltha}
95VOLTHA_CHART_VERSION=${VOLTHA_CHART_VERSION:-latest}
96VOLTHA_BBSIM_CHART=${VOLTHA_BBSIM_CHART:-onf/bbsim}
Matteo Scandolodcd29f52019-10-07 15:42:42 -070097VOLTHA_BBSIM_CHART_VERSION=${VOLTHA_BBSIM_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +000098VOLTHA_ADAPTER_SIM_CHART=${VOLTHA_ADAPTER_SIM_CHART:-onf/voltha-adapter-simulated}
David Bainbridge90fd8e32019-08-21 23:32:47 +000099VOLTHA_ADAPTER_SIM_CHART_VERSION=${VOLTHA_ADAPTER_SIM_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +0000100VOLTHA_ADAPTER_OPEN_OLT_CHART=${VOLTHA_ADAPTER_OPEN_OLT_CHART:-onf/voltha-adapter-openolt}
David Bainbridge90fd8e32019-08-21 23:32:47 +0000101VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION=${VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION:-latest}
David Bainbridgee10f6d52019-07-25 00:28:13 +0000102VOLTHA_ADAPTER_OPEN_ONU_CHART=${VOLTHA_ADAPTER_OPEN_ONU_CHART:-onf/voltha-adapter-openonu}
David Bainbridge90fd8e32019-08-21 23:32:47 +0000103VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION=${VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION:-latest}
Andrea Campanella21323292019-12-18 11:44:19 -0800104ONOS_CHART_VERSION=${ONOS_CHART_VERSION:-latest}
David Bainbridge70c0ea82019-11-14 23:25:26 +0000105EXTRA_HELM_INSTALL_ARGS=
uottrembb16d3982020-02-28 08:34:36 +0100106NUM_OF_BBSIM=${NUM_OF_BBSIM:-1}
107MAX_NUM_OF_BBSIM=10
Test Userba1e7e72019-07-10 22:27:54 +0000108
109HAVE_GO=$(which go >/dev/null 2>&1 && echo "yes" || echo "no")
110HOSTOS=$(uname -s | tr "[:upper:]" "[:lower:"])
111HOSTARCH=$(uname -m | tr "[:upper:]" "[:lower:"])
112if [ $HOSTARCH == "x86_64" ]; then
113 HOSTARCH="amd64"
114fi
Test User7d866122019-07-09 17:52:35 +0000115
uottrembb16d3982020-02-28 08:34:36 +0100116# check number (range) of bbsim, max bbsim must not exceed 10 instances!
117# note: instances will be numbered from 0 to 9
118if [ "$1" == "up" ]; then
119 if [ "$NUM_OF_BBSIM" -lt 1 ]; then
120 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid setting of BBSIM instances. NUM_OF_BBSIM is less than 1${NORMAL}"
121 exit 1
122 fi
123 if [ "$NUM_OF_BBSIM" -gt $MAX_NUM_OF_BBSIM ]; then
124 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid setting of BBSIM instances. NUM_OF_BBSIM is greater than $MAX_NUM_OF_BBSIM${NORMAL}"
125 exit 1
126 fi
127fi
Test User7d866122019-07-09 17:52:35 +0000128# Verify TYPE setting
129if [ $(echo ":minimal:full:" | grep -ic ":$TYPE:") -eq 0 ]; then
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700130 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid \$TYPE value of '$TYPE'. Should be 'minimal' or 'full'${NORMAL}"
Test User7d866122019-07-09 17:52:35 +0000131 exit 1
132fi
133
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800134function get_service_ep() {
135 local NS=$1
136 local NAME=$2
137 kubectl -n $NS get service $NAME -o json | jq -r '.spec.clusterIP + ":" + (.spec.ports[0].port|tostring)'
138}
139
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000140# Used to verify configuration values are set to "yes" or "no" value or convert
141# equivalents to "yes" or "no"
142function verify_yes_no() {
143 local VAR=$1
144 local VAL=$(eval echo \$$VAR)
145 if [ $(echo ":y:yes:true:n:no:false:1:0:" | grep -ic ":$VAL:") -eq 0 ]; then
146 >&2 echo -e "${RED}${BOLD}${ERROR}ERROR:${NORMAL}${RED} Invalid '$VAR' value of '$VAL'. Should be 'yes' or 'no'${NORMAL}"
147 echo "INVALID"
148 return 1
149 fi
150 if [ $(echo ":y:yes:true:1:" | grep -ic ":$VAL:") -eq 1 ]; then
151 echo "yes"
152 else
153 echo "no"
154 fi
155 return 0
156}
Test User7d866122019-07-09 17:52:35 +0000157
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000158ALL_YES_NO="\
David K. Bainbridge484d80c2020-03-05 21:44:34 -0800159 ENABLE_ONOS_EXTRANEOUS_RULES \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000160 WITH_TIMINGS \
161 WITH_BBSIM \
162 WITH_RADIUS \
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800163 WITH_EAPOL \
164 WITH_DHCP \
165 WITH_IGMP \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000166 WITH_ONOS \
David Bainbridge99ac7a22019-08-31 02:26:43 +0000167 WITH_CHAOS \
David Bainbridge46505fb2019-10-01 21:13:20 +0000168 WITH_ADAPTERS \
169 WITH_SIM_ADAPTERS \
170 WITH_OPEN_ADAPTERS \
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800171 WITH_PORT_FORWARDS \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000172 CONFIG_SADIS \
173 JUST_K8S \
174 DEPLOY_K8S \
175 INSTALL_ONOS_APPS \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000176 INSTALL_KUBECTL \
177 INSTALL_HELM \
David Bainbridge46505fb2019-10-01 21:13:20 +0000178 UPDATE_HELM_REPOS \
David Bainbridge4f1b5562019-08-19 04:46:52 +0000179 WAIT_ON_DOWN \
David Bainbridge70c0ea82019-11-14 23:25:26 +0000180 ONLY_ONE \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000181 "
David Bainbridge5b7b96b2019-07-25 20:29:13 +0000182
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000183ALL_OPTIONS="\
184 NAME \
185 TYPE \
186 $ALL_YES_NO \
187 VOLTHA_LOG_LEVEL \
188 VOLTHA_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000189 VOLTHA_CHART_VERSION \
190 VOLTHA_BBSIM_CHART \
191 VOLTHA_BBSIM_CHART_VERSION \
uottrembd5a20572020-03-06 09:15:01 +0100192 NUM_OF_BBSIM \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000193 VOLTHA_ADAPTER_SIM_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000194 VOLTHA_ADAPTER_SIM_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000195 VOLTHA_ADAPTER_OPEN_OLT_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000196 VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000197 VOLTHA_ADAPTER_OPEN_ONU_CHART \
David Bainbridge90fd8e32019-08-21 23:32:47 +0000198 VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION \
Andrea Campanella21323292019-12-18 11:44:19 -0800199 ONOS_CHART_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000200 ONOS_API_PORT \
201 ONOS_SSH_PORT \
202 VOLTHA_API_PORT \
203 VOLTHA_SSH_PORT \
204 VOLTHA_ETCD_PORT \
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800205 VOLTHA_KAFKA_PORT \
David K. Bainbridge8f7f30b2020-01-08 13:06:16 -0800206 VK_RELEASE \
207 KIND_VERSION \
208 VOLTCTL_VERSION \
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000209 "
David Bainbridge01294952019-07-30 19:33:45 +0000210
David Bainbridge2a0b8a42019-08-16 17:39:29 +0000211# Iterate over yes/no configuration options and validate
212for VAR in $ALL_YES_NO; do
213 eval $VAR=$(verify_yes_no $VAR)
214 if [ "$(eval echo \$$VAR)" == "INVALID" ]; then
215 exit 1;
216 fi
217done
David Bainbridgeb270c202019-07-26 01:44:42 +0000218
David Bainbridge0774b232019-08-02 06:37:19 +0000219mkdir -p .voltha
220touch .voltha/ports
221HAVE=$(grep $NAME .voltha/ports)
222if [ "$HAVE X" == " X" ]; then
223 # Find free port prefix
224 START=81
225 while true; do
226 if [ $(grep -c $START .voltha/ports) -eq 0 ]; then
227 break
228 fi
229 START=$(expr $START + 1)
230 done
231 DELTA=$(expr $START - 81)
David Bainbridgea2595422019-10-22 03:54:28 +0000232 ONOS_API_PORT=${ONOS_API_PORT:-${START}81}
233 ONOS_SSH_PORT=${ONOS_SSH_PORT:-${START}01}
234 VOLTHA_API_PORT=${VOLTHA_API_PORT:-5$(expr 55 + $DELTA)55}
235 VOLTHA_SSH_PORT=${VOLTHA_SSH_PORT:-$(expr 50 + $DELTA)22}
236 VOLTHA_ETCD_PORT=${VOLTHA_ETCD_PORT:-$(expr 23 + $DELTA)79}
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800237 VOLTHA_KAFKA_PORT=${VOLTHA_KAFKA_PORT:-$(expr 90 + $DELTA)92}
Test User01ed0642019-07-03 20:17:06 +0000238else
David Bainbridge0774b232019-08-02 06:37:19 +0000239 VALUES=$(echo $HAVE | sed -e 's/\s//g' | cut -d= -f2)
David Bainbridgea2595422019-10-22 03:54:28 +0000240 ONOS_API_PORT=${ONOS_API_PORT:-$(echo $VALUES | cut -d, -f1)}
241 ONOS_SSH_PORT=${ONOS_SSH_PORT:-$(echo $VALUES | cut -d, -f2)}
242 VOLTHA_API_PORT=${VOLTHA_API_PORT:-$(echo $VALUES | cut -d, -f3)}
243 VOLTHA_SSH_PORT=${VOLTHA_SSH_PORT:-$(echo $VALUES | cut -d, -f4)}
244 VOLTHA_ETCD_PORT=${VOLTHA_ETCD_PORT:-$(echo $VALUES | cut -d, -f5)}
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800245 VOLTHA_KAFKA_PORT=${VOLTHA_KAFKA_PORT:-$(echo $VALUES | cut -d, -f6)}
246
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800247 # A bit of a hueristic required here as the KAFKA port forward was
248 # added after the .voltha/ports files was created. Basically, if
249 # the VOLTHA_KAFKA_PORT isn't in the file then calculate the original
250 # DELTA from the VOLTHA_SSH_PORT and apply it to the VOLTHA_KAFKA_PORT
251 if [ -z "$VOLTHA_KAFKA_PORT" ]; then
252 DELTA=$((VOLTHA_SSH_PORT/100-50))
253 VOLTHA_KAFKA_PORT=${VOLTHA_KAFKA_PORT:-$(expr 90 + $DELTA)92}
254 fi
Test User01ed0642019-07-03 20:17:06 +0000255fi
256
David Bainbridge0774b232019-08-02 06:37:19 +0000257PORTTMP=$(mktemp -u)
258cat .voltha/ports | grep -v $NAME > $PORTTMP
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800259echo "$NAME=$ONOS_API_PORT,$ONOS_SSH_PORT,$VOLTHA_API_PORT,$VOLTHA_SSH_PORT,$VOLTHA_ETCD_PORT,$VOLTHA_KAFKA_PORT" >> $PORTTMP
David Bainbridge0774b232019-08-02 06:37:19 +0000260cp $PORTTMP .voltha/ports
261rm -f $PORTTMP
262
David Bainbridge27790d62019-08-13 22:43:19 +0000263export ONOS_API_PORT ONOS_SSH_PORT
David Bainbridge01294952019-07-30 19:33:45 +0000264
Test Userd87942b2019-07-03 07:20:24 +0000265IDX=1
David Bainbridgee87067b2019-08-12 22:00:12 +0000266CLOCK="TIME:"
David Bainbridge38dc1e82019-08-12 15:18:45 +0000267SPIN_PARTS=
268NOT_VERIFIED=
David Bainbridgef858a022019-08-14 21:25:11 +0000269THEX=
270BUILD=
271CROSS=
272ENTER=
David Bainbridge38dc1e82019-08-12 15:18:45 +0000273VERIFIED=
274HELM=
275OLD_KEY=
276BIRD=
277HIGH_VOLTAGE=
278PLUG=
279RESTART=
280FORWARD=
281INSTALL=
282STOP=
283GO=
284DOWNLOAD=
285GEAR=
286NO_ENTRY=
287LOCK=
288
289if [ $FANCY -eq 1 ]; then
290 SPIN_PARTS="\
291 \xe2\xa2\x8e\xe2\xa1\xb0 \
292 \xe2\xa2\x8e\xe2\xa1\xa1 \
293 \xe2\xa2\x8e\xe2\xa1\x91 \
294 \xe2\xa2\x8e\xe2\xa0\xb1 \
295 \xe2\xa0\x8e\xe2\xa1\xb1 \
296 \xe2\xa2\x8a\xe2\xa1\xb1 \
297 \xe2\xa2\x8c\xe2\xa1\xb1 \
298 \xe2\xa2\x86\xe2\xa1\xb1 \
299 "
David Bainbridgee87067b2019-08-12 22:00:12 +0000300 CLOCK="\xe2\x8f\xb1"
David Bainbridgef858a022019-08-14 21:25:11 +0000301 THEX="${RED}${BOLD}\xe2\x9c\x97\x20${NORMAL}"
302 ENTER="${YELLOW}${BOLD}\xe2\x8e\x86${NORMAL}"
303 CROSS="${YELLOW}${BOLD}\xe2\x9c\x9a${NORMAL}"
304 BUILD="${YELLOW}${BOLD}\xf0\x9f\x8f\x97${NORMAL}"
305 NOT_VERIFIED="$BUILD"
306 VERIFIED="${GREEN}${BOLD}\xe2\x9c\x93\x20${NORMAL}"
307 HELM="${BLUE}${BOLD}\xE2\x8E\x88${NORMAL}"
David Bainbridge38dc1e82019-08-12 15:18:45 +0000308 OLD_KEY="\xF0\x9F\x97\x9D"
309 BIRD="\xF0\x9F\x90\xA6"
310 HIGH_VOLTAGE="\xE2\x9A\xA1"
311 PLUG="\xF0\x9F\xa7\xa9"
312 RESTART="\xf0\x9f\x94\x84"
313 FORWARD="\xE2\x87\xA8"
314 INSTALL="\xF0\x9F\x8F\x97"
315 STOP="\xf0\x9f\x9b\x91"
316 GO="\xf0\x9f\x9a\x80"
317 DOWNLOAD="\xf0\x9f\x93\xa5"
318 GEAR="\xe2\x9a\x99"
319 NO_ENTRY="\xe2\x9b\x94"
320 LOCK="\xf0\x9f\x94\x92"
321fi
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700322
David Bainbridge712afb82019-08-14 19:55:58 +0000323duration() {
David Bainbridgee87067b2019-08-12 22:00:12 +0000324 local h=$(expr $1 / 3600)
325 local m=$(expr $1 % 3600 / 60)
326 local s=$(expr $1 % 60)
327 local t=""
328
329 if [ $h -gt 0 ]; then
330 t="$t${h}h"
331 fi
332 if [ $m -gt 0 ]; then
333 t="$t${m}m"
334 fi
David Bainbridge712afb82019-08-14 19:55:58 +0000335 echo "$t${s}s"
336}
337
338printtime() {
339 local INDENT=
340 if [ "$1" == "-" ]; then
341 INDENT=" "
342 shift
343 fi
344 echo -e "$INDENT $CLOCK $(duration $1)"
David Bainbridgee87067b2019-08-12 22:00:12 +0000345}
346
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700347bspin() {
Test Userd87942b2019-07-03 07:20:24 +0000348 IDX=1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700349 local INDENT=
350 if [ "$1" == "-" ]; then
351 INDENT=" "
352 shift
353 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000354 if [ $FANCY -eq 0 ]; then
355 LINE=$(echo $* | sed -e 's/[\s+-]//g')
356 if [ "$LINE X" == " X" ]; then
357 return
358 fi
359 echo -e "$CIVIS$INDENT$*"
360 else
361 echo -en "$CIVIS$INDENT $*"
362 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700363}
364
365sspin() {
366 local INDENT=
367 if [ "$1" == "-" ]; then
368 INDENT=" "
369 shift
370 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000371 if [ $FANCY -eq 0 ]; then
372 LINE=$(echo $* | sed -e 's/[\s+-]//g')
373 if [ "$LINE X" == " X" ]; then
374 return
375 fi
376 echo -e "$INDENT$*"
377 else
378 C=$(echo $SPIN_PARTS | cut '-d ' -f $IDX)
379 echo -en "\r$INDENT$C $*"
380 IDX=$(expr $IDX + 1)
381 if [ $IDX -gt 8 ]; then
382 IDX=1
383 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700384 fi
385}
386
387espin() {
388 local INDENT=
389 if [ "$1" == "-" ]; then
390 INDENT=" "
391 shift
392 fi
David Bainbridge38dc1e82019-08-12 15:18:45 +0000393 if [ $FANCY -eq 0 ]; then
394 LINE=$(echo $* | sed -e 's/[\s+-]//g')
395 if [ "$LINE X" == " X" ]; then
396 return
397 fi
398 echo -e "$INDENT$*"
399 else
400 echo -e "\r$INDENT$*$CNORM"
401 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700402}
403
David Bainbridgeac7f8072019-08-01 22:15:33 +0000404if [ "$1" == "get" -a "$2" == "voltconfig" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000405 echo "$HOME/.volt/config-$NAME"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000406 exit
407fi
408
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700409if [ $# -ne 1 -o $(echo ":up:down:dump:" | grep -c ":$1:") -ne 1 ]; then
David Bainbridgeac7f8072019-08-01 22:15:33 +0000410 >&2 echo "What wouild you like to do today:"
411 >&2 echo " up - bring up voltha"
412 >&2 echo " down - tear down voltha"
413 >&2 echo " dump - create a debug dump of running system"
414 exit 1
415fi
416
David Bainbridge4f1b5562019-08-19 04:46:52 +0000417push_onos_config() {
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800418 local TYPE=$1
419 local MSG=$2
420 local RESOURCE=$3
421 local DATA=$4
David Bainbridge4f1b5562019-08-19 04:46:52 +0000422
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800423 # Thanks to the latest version of ONOS using the return code 207 this gets a
424 # whole lot nastier. Can't thank them enough for doing this. So in order to
425 # capture the command and the output in the log file as well as capture the
426 # status code to verify it is 200 and not 207 mutltiple files and a bit of
427 # hackery must be used. Thanks again ONOS.
428 local CMD_ECHO=$(mktemp -u)
429 local CMD_OUTPUT=$(mktemp -u)
430 local SC_OUTPUT=$(mktemp -u)
431
David Bainbridge4f1b5562019-08-19 04:46:52 +0000432 bspin - "$MSG $GEAR"
433 while true; do
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800434 if [ $TYPE == "file" ]; then
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800435 (set -x; curl --fail -sSL --user karaf:karaf -w "%{http_code}" -o $CMD_OUTPUT -X POST -H Content-Type:application/json http://$_ONOS_API_EP/onos/v1/$RESOURCE --data @$DATA >$SC_OUTPUT 2>/dev/null) >>$CMD_ECHO 2>&1
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800436 fi
437 if [ $TYPE == "json" ]; then
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800438 (set -x; curl --fail -sSL --user karaf:karaf -w "%{http_code}" -o $CMD_OUTPUT -X POST -H Content-Type:application/json http://$_ONOS_API_EP/onos/v1/$RESOURCE --data $DATA >$SC_OUTPUT 2>/dev/null) >>$CMD_ECHO 2>&1
Matteo Scandolo78dfee02020-02-13 16:18:03 -0800439 fi
David K. Bainbridgeb4b163b2020-02-19 15:55:06 -0800440 RESULT=$?
441 # Dump everything to the log
442 cat $CMD_ECHO >> $LOG
443 cat $CMD_OUTPUT >> $LOG
444 SC=$(cat $SC_OUTPUT)
445
446 # clean up temp files
447 rm -f $CMD_ECHO $CMD_OUTPUT $SC_OUTPUT
448 if [ $RESULT -eq 0 -a "$SC" == "200" ]; then
David Bainbridge4f1b5562019-08-19 04:46:52 +0000449 break
450 fi
Matteo Scandolo9a77a732020-01-09 14:24:12 -0800451 sleep 1
David Bainbridge4f1b5562019-08-19 04:46:52 +0000452 sspin -
453 done
454 espin - $VERIFIED
455}
456
Matteo Scandolo9a77a732020-01-09 14:24:12 -0800457check_onos_app_active() {
458 local APP_ID=$1
459
460 bspin - "Checking that $APP_ID is active $CLOCK"
461 while true; do
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800462 (set -x; curl --fail -sSL --user karaf:karaf -X GET http://$_ONOS_API_EP/onos/v1/applications/$APP_ID | grep ACTIVE >>$LOG 2>&1) >>$LOG 2>&1
Matteo Scandolo9a77a732020-01-09 14:24:12 -0800463 if [ $? -eq 0 ]; then
464 break
465 fi
466 sleep 1
467 sspin -
468 done
469 sleep 5 # OSGI components take a little longer that the app to activate
470 espin - $VERIFIED
471}
472
David Bainbridge4f1b5562019-08-19 04:46:52 +0000473override_onos_app() {
474 local APP=$1
475 local NAME=$(basename $APP | sed -e 's/^[0-9][0-9]*-//g' -e 's/-.*$//g')
476 while true; do
477 sspin -
478 # Attempt to delete old version (if it exists)
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800479 (set -x; curl --fail -sSL --user karaf:karaf -X DELETE http://$_ONOS_API_EP/onos/v1/applications/$NAME >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge4f1b5562019-08-19 04:46:52 +0000480 sspin -
481 if [ $? -ne 0 ]; then
482 continue
483 fi
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800484 (set -x; curl --fail -sSL --user karaf:karaf -X POST -H Content-Type:application/octet-stream http://$_ONOS_API_EP/onos/v1/applications?activate=true --data-binary @$APP >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge4f1b5562019-08-19 04:46:52 +0000485 if [ $? -eq 0 ]; then
486 break
487 fi
488 sleep .2
489 done
490}
491
492activate_onos_app() {
493 local MSG="$1"
494 local APP=$2
495
496 bspin - "$MSG $GO"
497 while true; do
498 sspin -
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -0800499 (set -x; curl --fail -sSL --user karaf:karaf -X POST http://$_ONOS_API_EP/onos/v1/applications/$APP/active >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge4f1b5562019-08-19 04:46:52 +0000500 if [ $? -eq 0 ]; then
501 break
502 fi
503 sleep .2
504 done
505 espin - "$VERIFIED"
506}
507
508count_pods() {
509 local NAMESPACE=$1; shift
510 if [ "$NAMESPACE" == "all-namespaces" ]; then
511 NAMESPACE="--all-namespaces"
512 else
513 NAMESPACE="-n $NAMESPACE"
514 fi
515 echo "$NAMESPACE" > /tmp/t
516 local STATES=$1; shift
517 echo "$STATES" >> /tmp/t
518 local PODS=$(kubectl get $NAMESPACE pod -o go-template="{{range .items}}{{.metadata.name}}/{{.status.phase}}/_{{range .status.containerStatuses}}{{.ready}}_{{end}} {{end}}")
519 local COUNT=0
520 local PATTERNS="$*"
521 for POD in $PODS; do
522 local NAME=$(echo $POD | cut -d/ -f 1)
523 local STATE=$(echo $POD | cut -d/ -f 2)
524 local CONTAINERS=$(echo $POD | cut -d/ -f 3 | sed -e 's/_/ /g')
525 if [ "$STATES" == "*" -o $(echo "$STATES" | grep -c ":$STATE:") -ne 0 ]; then
526 echo "IN WITH $POD" >> /tmp/t
527 local TOTAL=$(echo $CONTAINERS | wc -w)
528 local FOUND=$(echo $CONTAINERS | grep -o true | wc -l)
529 if [ $TOTAL -eq $FOUND ]; then
530 for PATTERN in $PATTERNS; do
531 echo "TEST $PATTERN AGAINST $NAME" >> /tmp/t
532 if [[ $NAME =~ $PATTERN ]]; then
533 echo "COUNT $NAME" >> /tmp/t
534 COUNT=$(expr $COUNT + 1)
535 break
536 fi
537 done
538 fi
539 fi
540 done
541 echo $COUNT >> /tmp/t
542 echo $COUNT
543}
544
545wait_for_pods() {
546 local INDENT=
547 if [ "$1" == "-" ]; then
548 INDENT=$1; shift
549 fi
550 local NAMESPACE=$1; shift
551 local EXPECT=$1; shift
552 local TYPE=$1; shift
553 local RETRY=$1; shift
554 local MESSAGE=$1; shift
555 local PATTERNS=$*
David Bainbridge99ac7a22019-08-31 02:26:43 +0000556 local STATES=":Running:"
557 if [ "$TYPE" == "not" ]; then
558 STATES="*"
559 fi
560 local HAVE=$(count_pods $NAMESPACE "$STATES" $PATTERNS)
David Bainbridge4f1b5562019-08-19 04:46:52 +0000561 local ALL=$HAVE
562 if [ "$TYPE" == "only" ]; then
563 ALL=$(count_pods "all-namespaces" "*" ".*")
564 fi
565 COUNT=$(expr 300 / 15)
566 bspin $INDENT $MESSAGE
567 sspin $INDENT
568 if [ $HAVE -ne $EXPECT -o $ALL -ne $HAVE ]; then
569 while [ $HAVE -ne $EXPECT -o $ALL -ne $HAVE ]; do
570 sspin $INDENT
571 COUNT=$(expr $COUNT - 1)
572 if [ $COUNT -eq 0 ]; then
David Bainbridge99ac7a22019-08-31 02:26:43 +0000573 HAVE=$(count_pods $NAMESPACE "$STATES" $PATTERNS)
David Bainbridge4f1b5562019-08-19 04:46:52 +0000574 ALL=$HAVE
575 if [ "$TYPE" == "only" ]; then
576 ALL=$(count_pods "all-namespaces" "*" ".*")
577 fi
578 COUNT=$(expr 300 / 15)
579 fi
580 sleep .15
581 done
582 fi
583 espin $INDENT $VERIFIED
584 if [ $HAVE -ne $EXPECT ]; then
585 return 1
586 fi
587 return 0
588}
589
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800590port_forward() {
591 local NS=$1
592 local SVC=$2
593 local FROM_PORT=$3
594 local TO_PORT=$4
595 local TAG=$SVC-$NAME
596
597 (set -x; _TAG=$TAG bash -c "while true; do kubectl port-forward -n $NS service/$SVC $FROM_PORT:$TO_PORT; done" >>$LOG 2>&1 &) >>$LOG 2>&1
598}
599
600kill_port_forward() {
601 local TAG=$1-$NAME
David Bainbridgec6871d22019-11-13 17:10:31 +0000602 local P_IDS=$(ps e -ww -A | grep "_TAG=$TAG" | grep -v grep | awk '{print $1}')
David Bainbridgebcf235b2019-11-12 21:33:58 +0000603 local PARENTS=
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800604 local KIDS=
David Bainbridgec6871d22019-11-13 17:10:31 +0000605 local UNKNOWN=
606 if [ ! -z "$P_IDS" ]; then
607 for P_ID in $P_IDS; do
608 local PP_ID=$(ps -o ppid $P_ID | tail -n +2)
609 if [ ! -z "$PP_ID" ]; then
610 if [ $PP_ID -eq 1 ]; then
611 PARENTS="$PARENTS $P_ID"
612 else
613 KIDS="$KIDS $P_ID"
614 fi
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800615 else
David Bainbridgec6871d22019-11-13 17:10:31 +0000616 UNKNOWN="$UNKNOWN $P_ID"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800617 fi
618 done
David Bainbridgec6871d22019-11-13 17:10:31 +0000619 (set -x; kill -9 $PARENTS $KIDS $UNKNOWN >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800620 fi
621}
622
David Bainbridgeac7f8072019-08-01 22:15:33 +0000623if [ "$1" == "down" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000624 echo "Tearing down voltha cluster $NAME"
625 LOG="down-$NAME.log"
626 echo $(date -u +"%Y%m%dT%H%M%SZ") >$LOG
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800627 bspin "Remove port-forwards: onos-ui-$NAME"
628 kill_port_forward onos-ui
629 sspin "Remove port-forwards: onos-ssh-$NAME$CEOL"
630 kill_port_forward onos-ssh
631 sspin "Remove port-forwards: voltha-api-$NAME$CEOL"
632 kill_port_forward voltha-api
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800633 sspin "Remove port-forwards: voltha-etcd-$NAME$CEOL"
634 kill_port_forward voltha-etcd-cluster-client
David K. Bainbridge00ecd382020-02-28 12:31:58 -0800635 sspin "Remove port-forwards: voltha-kafka-$NAME$CEOL"
636 kill_port_forward voltha-kafka
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800637 espin "$VERIFIED Remove port-forwards$CEOL"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000638 if [ $DEPLOY_K8S == "yes" ]; then
639 if [ -x ./bin/kind ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000640 bspin "Delete Kubernetes Kind Cluster"
641 (set -x; ./bin/kind delete cluster --name voltha-$NAME >>$LOG 2>&1) >>$LOG 2>&1
642 espin $VERIFIED
David Bainbridgeac7f8072019-08-01 22:15:33 +0000643 else
David Bainbridge0774b232019-08-02 06:37:19 +0000644 espin "$NO_ENTRY Delete Kubernetes Kind Cluster: kind command not found"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000645 fi
646 else
647 EXISTS=$(helm list -q)
648 EXPECT="etcd-operator onos open-olt open-onu sim voltha bbsim radius"
David Bainbridge0774b232019-08-02 06:37:19 +0000649 bspin "Remove Helm Deployments"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000650 for i in $EXISTS; do
uottrembb16d3982020-02-28 08:34:36 +0100651 for j in $EXPECT; do
652 if [[ $i =~ $j ]]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000653 sspin "Remove Helm Deployments: $i$CEOL"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800654 (set -x; ./bin/helm delete --no-hooks --purge $i >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000655 fi
656 done
uottrembb16d3982020-02-28 08:34:36 +0100657 done
David Bainbridge0774b232019-08-02 06:37:19 +0000658 espin "$VERIFIED Remove Helm Deployments$CEOL"
David Bainbridge4f1b5562019-08-19 04:46:52 +0000659 if [ "$WAIT_ON_DOWN" == "yes" ]; then
660 # There should only be 13 or 15 PODs in the kube-system name
661 # space and no other PODs
David Bainbridge4f1b5562019-08-19 04:46:52 +0000662 PODS="coredns-.* \
663 etcd-voltha-$NAME-control-plane \
664 kindnet-.* \
665 kube-apiserver-voltha-$NAME-control-plane \
666 kube-controller-manager-voltha-$NAME-control-plane \
667 kube-proxy-.* \
668 kube-scheduler-voltha-$NAME-control-plane \
669 tiller-deploy-.*"
670 EXPECT=$(test "$TYPE" == "minimal" && echo "13" || echo "15")
David Bainbridge99ac7a22019-08-31 02:26:43 +0000671 PODS="adapter-.* \
672 bbsim.* \
673 etcd-operator.* \
674 radius.* \
675 voltha-.*"
Matteo Scandolo73442f92020-01-29 09:53:22 -0800676
David Bainbridge99ac7a22019-08-31 02:26:43 +0000677 EXPECT=0
678
Matteo Scandolo73442f92020-01-29 09:53:22 -0800679 if [ "$WITH_ONOS" == "yes" ]; then
680 ONOS_PODS="onos-.*"
681 wait_for_pods "default" $EXPECT "not" -1 "Waiting for ONOS PODs to terminate" $ONOS_PODS
682 fi
David Bainbridge99ac7a22019-08-31 02:26:43 +0000683 wait_for_pods "voltha" $EXPECT "not" -1 "Waiting for VOLTHA PODs to terminate" $PODS
David Bainbridge4f1b5562019-08-19 04:46:52 +0000684 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000685 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700686 exit
David Bainbridgeac7f8072019-08-01 22:15:33 +0000687fi
688
689if [ "$1" == "dump" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000690 LOG="dump-$NAME.log"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000691 TS=$(date -u +"%Y%m%dT%H%M%SZ")
David Bainbridge76514a02019-10-08 01:50:35 +0000692 if [ ! -z "$DUMP_FROM" ]; then
693 TS=$(echo $DUMP_FROM | sed -e 's/[:-]//g')
694 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000695 WORK=$(mktemp -u -d)
David Bainbridge0774b232019-08-02 06:37:19 +0000696 DATA=$WORK/voltha-debug-dump-$NAME-$TS
David Bainbridgeac7f8072019-08-01 22:15:33 +0000697 mkdir -p $DATA
698 echo $TS > $LOG
David Bainbridge0774b232019-08-02 06:37:19 +0000699 echo -e "Capturing debug dump to voltha-debug-dump-$NAME-$TS.tgz"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000700 bspin - "Copy install log"
David Bainbridge0774b232019-08-02 06:37:19 +0000701 if [ -f install-$NAME.log ]; then
702 (set -x; cp install-$NAME.log $DATA/install-$NAME.log) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000703 espin - $VERIFIED
704 else
David Bainbridge0774b232019-08-02 06:37:19 +0000705 espin - "$NO_ENTRY Copy install log: install-$NAME.log not found"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000706 fi
707 bspin - "Dumping Kubernetes PODs"
708 (set -x; kubectl get --all-namespaces pods >> $DATA/all-pods.txt 2>&1) >>$LOG 2>&1
709 espin - $VERIFIED
710 bspin - "Dumping Kubernetes SERVICEs"
711 (set -x; kubectl get --all-namespaces svc >> $DATA/all-services.txt 2>&1) >>$LOG 2>&1
712 espin - $VERIFIED
713 bspin - "Dumping Kubernetes EVENTs"
714 (set -x; kubectl get --all-namespaces events >> $DATA/all-events.txt 2>&1) >>$LOG 2>&1
715 espin - $VERIFIED
716 bspin - "Dumping VOLTHA POD details"
Matteo Scandolodcd29f52019-10-07 15:42:42 -0700717 PODS="$(kubectl -n default get pod -o name | grep onos | sed -e 's/^/default:/g') $(kubectl get -n voltha pod -o name | sed -e 's/^/voltha:/g')"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000718 SINCE=
719 if [ ! -z "$DUMP_FROM" ]; then
720 SINCE="--since-time=$DUMP_FROM"
721 fi
David Bainbridgeac7f8072019-08-01 22:15:33 +0000722 for POD in $PODS; do
David Bainbridge1f0655a2019-10-01 22:08:48 +0000723 NS=$(echo $POD | cut -d: -f1)
724 POD=$(echo $POD | cut -d: -f2)
David Bainbridgeac7f8072019-08-01 22:15:33 +0000725 sspin - "Dumping VOLTHA POD details: $POD$CEOL"
726 mkdir -p $DATA/$POD
David Bainbridge1f0655a2019-10-01 22:08:48 +0000727 (set -x; kubectl describe -n $NS $POD >> $DATA/$POD/describe.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000728 sspin - "Dumping VOLTHA POD details: $POD"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000729 (set -x; kubectl logs -n $NS --all-containers $SINCE --previous $LOG_ARGS $POD >> $DATA/$POD/logs-previous.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000730 sspin - "Dumping VOLTHA POD details: $POD"
David Bainbridgecfd7ca12019-10-06 03:31:41 +0000731 (set -x; kubectl logs -n $NS --all-containers $SINCE $LOG_ARGS $POD >> $DATA/$POD/logs-current.txt 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000732 sspin - "Dumping VOLTHA POD details: $POD"
733 done
734 espin - "$VERIFIED Dumping VOLTHA POD details$CEOL"
735 bspin - "Dumping ETCD"
736 if [ "$(which etcdctl) X" != " X" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000737 (set -x; ETCDCTL_API=3 etcdctl --endpoints localhost:$VOLTHA_ETCD_PORT get --prefix service/voltha | hexdump -C >> $DATA/etcd.hex 2>&1) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000738 espin - $VERIFIED
739 else
740 espin - "$NO_ENTRY Dumping ETCD: etcdctl command not available"
741 fi
David Bainbridge0774b232019-08-02 06:37:19 +0000742 bspin - "Creating compressed TAR: voltha-debug-dump-$NAME-$TS.tgz"
743 (set -x; tar -C $WORK -zcf voltha-debug-dump-$NAME-$TS.tgz ./voltha-debug-dump-$NAME-$TS) >>$LOG 2>&1
David Bainbridgeac7f8072019-08-01 22:15:33 +0000744 espin - $VERIFIED
745 bspin - "Cleanup"
746 (set -x; rm -rf $WORK) >>$LOG 2>&1
747 espin - $VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +0000748 bspin - "$(ls -l voltha-debug-dump-$NAME-$TS.tgz)"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000749 espin - $VERIFIED
750 exit
751fi
752
David Bainbridge0774b232019-08-02 06:37:19 +0000753LOG="install-$NAME.log"
David Bainbridgeac7f8072019-08-01 22:15:33 +0000754date > $LOG
David Bainbridge0774b232019-08-02 06:37:19 +0000755echo "PORTS=$ONOS_API_PORT,$ONOS_SSH_PORT,$VOLTHA_API_PORT,$VOLTHA_SSH_PORT,$VOLTHA_ETCD_PORT" >> $LOG
David Bainbridgeac7f8072019-08-01 22:15:33 +0000756
757# Output install options to log
758echo "OPTIONS" >> $LOG
David Bainbridgeac7f8072019-08-01 22:15:33 +0000759for O in $ALL_OPTIONS; do
760 VAL=$(eval echo \$$O)
David Bainbridgeac7f8072019-08-01 22:15:33 +0000761 if [ ! -z "$VAL" ]; then
762 printf " %-30s = %s\n" $O $VAL >> $LOG
763 fi
764done
765
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700766helm_install() {
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700767 local INDENT=
768 if [ "$1" == "-" ]; then
769 INDENT=$1; shift
770 fi
771 local NAMESPACE=$1; shift
David Bainbridge0774b232019-08-02 06:37:19 +0000772 local INAME=$1; shift
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700773 local CHART=$1; shift
David Bainbridge90fd8e32019-08-21 23:32:47 +0000774 local CHART_VERSION=$1; shift
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700775 local MESSAGE=$*
776
David Bainbridge90fd8e32019-08-21 23:32:47 +0000777 if [ "$CHART_VERSION X" != " X" -a "$CHART_VERSION" != "latest" ]; then
778 CHART_VERSION="--version $CHART_VERSION"
779 else
780 CHART_VERSION=
781 fi
782
David Bainbridge99ac7a22019-08-31 02:26:43 +0000783 local CHART_ARGS=
784 if [ -r "${INAME}-values.yaml" ]; then
785 CHART_ARGS="-f ${INAME}-values.yaml"
786 fi
787
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700788 COUNT=$(expr 300 / 15)
789 bspin $INDENT $MESSAGE
David Bainbridge70c0ea82019-11-14 23:25:26 +0000790 (set -x; helm install -f $NAME-values.yaml $CHART_ARGS $EXTRA_HELM_INSTALL_ARGS --set defaults.log_level=$VOLTHA_LOG_LEVEL --namespace $NAMESPACE --name $INAME $CHART_VERSION $EXTRA_HELM_FLAGS $CHART >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700791 SUCCESS=$?
792 while [ $SUCCESS -ne 0 ]; do
793 sspin $INDENT
794 COUNT=$(expr $COUNT - 1)
795 if [ $COUNT -eq 0 ]; then
Andy Baviere22ff252019-12-19 11:40:31 -0700796 (set -x; helm delete --purge $INAME >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge99ac7a22019-08-31 02:26:43 +0000797 (set -x; helm install -f $NAME-values.yaml $CHART_ARGS --set defaults.log_level=$VOLTHA_LOG_LEVEL --namespace $NAMESPACE --name $INAME $CHART_VERSION $EXTRA_HELM_FLAGS $CHART >>$LOG 2>&1) >>$LOG 2>&1
Andy Baviere22ff252019-12-19 11:40:31 -0700798 SUCCESS=$?
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700799 COUNT=$(expr 300 / 15)
800 fi
801 sleep .15
802 done
803 espin $INDENT $VERIFIED
804}
805
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700806echo "INSTALL TYPE: $TYPE" >> $LOG
807
808bspin "Verify GOPATH"
809export GOPATH=$(pwd)
Test User3d7ad8e2019-07-03 06:15:44 +0000810mkdir -p $GOPATH/bin
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700811espin $VERIFIED
812
David Bainbridgee87067b2019-08-12 22:00:12 +0000813STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700814if [ "$INSTALL_KUBECTL" == "no" ]; then
815 bspin "Skip kubectl install"
816 espin $NO_ENTRY
Test Userc13bdc92019-07-03 20:57:49 +0000817else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700818 bspin "Verify kubectl $HELM"
819 if [ -x $GOPATH/bin/kubectl ]; then
820 espin $VERIFIED
821 else
822 espin $NOT_VERIFIED
823 bspin - "Download and install Kubernetes/kubectl $DOWNLOAD"
824 (set -x; curl -o $GOPATH/bin/kubectl -sSL https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/$HOSTOS/$HOSTARCH/kubectl >>$LOG 2>&1) >>$LOG 2>&1
825 (set -x; chmod 755 $GOPATH/bin/kubectl >>$LOG 2>&1) >>$LOG 2>&1
826 espin - $VERIFIED
827 fi
Test Userc13bdc92019-07-03 20:57:49 +0000828fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000829if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000830 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000831fi
Test Userc13bdc92019-07-03 20:57:49 +0000832
David Bainbridgee87067b2019-08-12 22:00:12 +0000833STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700834if [ "$DEPLOY_K8S" == "no" ]; then
835 bspin "Skip Kubernetes/Kind Deployment"
836 espin $NO_ENTRY
837else
Test Userba1e7e72019-07-10 22:27:54 +0000838 bspin "Verify Kubernetes/Kind $HELM"
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800839 IS_INSTALLED=0
840 OP_TYPE="install"
Test Userba1e7e72019-07-10 22:27:54 +0000841 if [ -x $GOPATH/bin/kind ]; then
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800842 OP_TYPE="upgrade"
843 if [ $($GOPATH/bin/kind --version | grep -c $KIND_VERSION) -eq 1 ]; then
844 IS_INSTALLED=1
845 espin $VERIFIED
846 fi
847 fi
848 if [ $IS_INSTALLED -eq 0 ]; then
Test Userba1e7e72019-07-10 22:27:54 +0000849 espin $NOT_VERIFIED
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800850 bspin - "Download and $OP_TYPE Kubernetes/kind $DOWNLOAD"
David Bainbridge9e2a6662019-07-11 17:07:57 +0000851 (set -x; curl -o $GOPATH/bin/kind -sSL https://github.com/kubernetes-sigs/kind/releases/download/$KIND_VERSION/kind-$HOSTOS-$HOSTARCH >>$LOG 2>&1) >>$LOG 2>&1
Test Userba1e7e72019-07-10 22:27:54 +0000852 (set -x; chmod 755 $GOPATH/bin/kind >>$LOG 2>&1) >>$LOG 2>&1
853 espin - $VERIFIED
854 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700855fi
856
David Bainbridgee87067b2019-08-12 22:00:12 +0000857if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000858 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000859fi
860
861STIME=$(date +%s)
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700862if [ "$INSTALL_HELM" == "no" ]; then
863 bspin "Skip Helm Install"
864 espin $NO_ENTRY
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700865else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700866 bspin "Verify Helm $HELM"
867 if [ -x $GOPATH/bin/helm ]; then
868 espin $VERIFIED
869 else
870 espin $NOT_VERIFIED
871 bspin - "Download and install Helm $DOWNLOAD"
David Bainbridgec6a6eb62019-10-18 22:50:07 +0000872 (set -x; curl -sSL https://git.io/get_helm.sh | DESIRED_VERSION=v2.14.3 USE_SUDO=false HELM_INSTALL_DIR=$GOPATH/bin bash >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700873 espin - $VERIFIED
874 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700875fi
David K. Bainbridgefe1fa8a2019-11-12 12:03:21 -0800876
David Bainbridgee87067b2019-08-12 22:00:12 +0000877if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000878 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000879fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700880
David Bainbridgee87067b2019-08-12 22:00:12 +0000881STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +0000882bspin "Verify voltctl $HIGH_VOLTAGE"
David Bainbridged2811972019-12-14 01:14:09 +0000883VOK=0
884VMESSAGE="install"
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800885export VC_VERSION="$VOLTCTL_VERSION"
886if [ "$VC_VERSION" == "latest" ]; then
887 export VC_VERSION=$(curl -sSL https://api.github.com/repos/opencord/voltctl/releases/latest | jq -r .tag_name | sed -e 's/^v//g')
888fi
Test User3d7ad8e2019-07-03 06:15:44 +0000889if [ -x $GOPATH/bin/voltctl ]; then
David Bainbridge1ba64f12019-12-18 00:40:13 +0000890 VHAVE=$($GOPATH/bin/voltctl version --clientonly -o json | jq -r .version)
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800891 if [ $? -eq 0 -a "$VHAVE" == "$VC_VERSION" ]; then
David Bainbridged2811972019-12-14 01:14:09 +0000892 VOK=1
David Bainbridge1ba64f12019-12-18 00:40:13 +0000893 espin $VERIFIED
894 else
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800895 VCHECK=$(echo -e "$VHAVE\n$VC_VERSION" | sort -V | head -1)
896 if [ "$VCHECK" == "$VHAVE" ]; then
897 VMESSAGE="upgrade"
898 else
899 VMESSAGE="downgrade"
900 fi
David Bainbridged2811972019-12-14 01:14:09 +0000901 fi
902fi
903
David Bainbridge1ba64f12019-12-18 00:40:13 +0000904if [ $VOK -eq 0 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700905 espin $NOT_VERIFIED
David Bainbridged2811972019-12-14 01:14:09 +0000906 bspin - "Download and $VMESSAGE voltctl $DOWNLOAD"
David K. Bainbridgeebf38d92020-02-10 10:46:31 -0800907 (set -x; curl -o $GOPATH/bin/voltctl -sSL https://github.com/opencord/voltctl/releases/download/v$VC_VERSION/voltctl-$VC_VERSION-$HOSTOS-$HOSTARCH >>$LOG 2>&1) >>$LOG 2>&1
Test User08ebbd92019-07-03 17:15:39 +0000908 (set -x; chmod 755 $GOPATH/bin/voltctl >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700909 espin - $VERIFIED
910fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000911if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000912 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000913fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700914
915bspin "Verify command PATH"
Test Userba1e7e72019-07-10 22:27:54 +0000916export PATH=$GOPATH/bin:$PATH
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700917espin $VERIFIED
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700918
David Bainbridgee87067b2019-08-12 22:00:12 +0000919STIME=$(date +%s)
Test Userba1e7e72019-07-10 22:27:54 +0000920if [ "$DEPLOY_K8S" == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +0000921 HAVE=$(kind get clusters | grep -c voltha-$NAME)
Test Userba1e7e72019-07-10 22:27:54 +0000922 bspin "Verify Kubernetes/Kind Cluster"
923 sspin
924 if [ $HAVE -eq 0 ]; then
David Bainbridge491b1bd2019-07-11 17:53:11 +0000925 espin $NOT_VERIFIED
926 bspin - "Verify cluster configuration"
David Bainbridge0774b232019-08-02 06:37:19 +0000927 if [ ! -r ./$NAME-cluster.cfg ]; then
David Bainbridge491b1bd2019-07-11 17:53:11 +0000928 espin - $NOT_VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +0000929 bspin - "Download cluster configuration: $TYPE-cluster.cfg to $NAME-cluster.cfg $DOWNLOAD"
David K. Bainbridgea00736b2020-01-08 14:33:17 -0800930 ERR_OUT=$(mktemp)
931 (set -x; curl --fail -o ./$NAME-cluster.cfg -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$TYPE-cluster.cfg >>$LOG 2>>$ERR_OUT) >>$LOG 2>&1
932 if [ $? -ne 0 ]; then
933 espin - $THEX
934 echo -e "${RED}${BOLD}${ERROR}ERROR: $NAME-cluster.cfg${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
935 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
936 rm -rf $ERR_OUT ./$NAME-cluster.cfg
937 exit 1
938 fi
939 rm -rf $ERR_OUT
940 else
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700941 espin - $VERIFIED
David K. Bainbridgea00736b2020-01-08 14:33:17 -0800942 fi
David Bainbridge0774b232019-08-02 06:37:19 +0000943 kind create cluster --name voltha-$NAME --config $NAME-cluster.cfg
David Bainbridge491b1bd2019-07-11 17:53:11 +0000944 else
945 espin $VERIFIED
Test Userba1e7e72019-07-10 22:27:54 +0000946 fi
947
David Bainbridge0774b232019-08-02 06:37:19 +0000948 export KUBECONFIG="$(kind get kubeconfig-path --name="voltha-$NAME")"
Test Userba1e7e72019-07-10 22:27:54 +0000949 P="coredns-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000950 etcd-voltha-$NAME-control-plane \
Test Userba1e7e72019-07-10 22:27:54 +0000951 kindnet-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000952 kube-apiserver-voltha-$NAME-control-plane \
953 kube-controller-manager-voltha-$NAME-control-plane \
Test Userba1e7e72019-07-10 22:27:54 +0000954 kube-proxy-.* \
David Bainbridge0774b232019-08-02 06:37:19 +0000955 kube-scheduler-voltha-$NAME-control-plane"
Test Userba1e7e72019-07-10 22:27:54 +0000956
957 EXPECT=$(test "$TYPE" == "minimal" && echo "12" || echo "14")
David Bainbridge4f1b5562019-08-19 04:46:52 +0000958 wait_for_pods - "kube-system" $EXPECT "includes" -1 "Waiting for system PODs to start" $P
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700959fi
David Bainbridgee87067b2019-08-12 22:00:12 +0000960if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +0000961 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +0000962fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700963
David Bainbridgee87067b2019-08-12 22:00:12 +0000964STIME=$(date +%s)
David Bainbridge4c6289c2019-09-03 21:11:32 +0000965COUNT=$(count_pods "kube-system" ":Running:" "tiller-deploy-.*")
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700966bspin "Verify Helm"
Test Userba1e7e72019-07-10 22:27:54 +0000967if [ $COUNT -ne 1 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700968 espin $NOT_VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000969 echo -e "Configuring Helm $GEAR"
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700970 if [ "$INSTALL_HELM" == "no" ]; then
971 bspin - "Skip Helm/Tiller Initialization"
972 espin - $NO_ENTRY
973 else
974 bspin - "Initialize Helm"
975 (set -x; helm init --upgrade >>$LOG 2>&1) >>$LOG 2>&1
976 espin - $VERIFIED
David Bainbridge4f1b5562019-08-19 04:46:52 +0000977 wait_for_pods - "kube-system" 1 "includes" -1 "Waiting for Tiller POD to start" "tiller-deploy-.*"
David K. Bainbridge0e89cb92019-07-17 11:30:10 -0700978 fi
Test Userb5712372019-07-03 21:52:17 +0000979 bspin - "Add Google Incubator repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700980 (set -x; helm repo add incubator https://kubernetes-charts-incubator.storage.googleapis.com >>$LOG 2>&1) >>$LOG 2>&1
981 espin - $VERIFIED
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700982
Test Userba1e7e72019-07-10 22:27:54 +0000983 # HACK (sort-of) - the config for tiller is about to be patched, which will
984 # cause the tiller pod to be recreated. This can sometimes cause a timing
985 # issue with the "wait_for_pods" call on tiller as it may incorrectly
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700986 # identify the running/ready tiller pod that is soon to be terminated as
Test Userba1e7e72019-07-10 22:27:54 +0000987 # what it is waiting for. To avoid this issue we do a clean scale down and
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -0700988 # scale up of the pod so the script controlls when it should be expecting
Test Userba1e7e72019-07-10 22:27:54 +0000989 # things
990 (set -x; kubectl -n kube-system scale deploy tiller-deploy --replicas=0 >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700991
Test Userb5712372019-07-03 21:52:17 +0000992 bspin - "Add Google Stable repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700993 (set -x; helm repo add stable https://kubernetes-charts.storage.googleapis.com >>$LOG 2>&1) >>$LOG 2>&1
994 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000995 bspin - "Add ONF repository to Helm"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700996 (set -x; helm repo add onf https://charts.opencord.org >>$LOG 2>&1) >>$LOG 2>&1
997 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +0000998 bspin - "Update Helm repository cache"
David K. Bainbridgeb7285432019-07-02 22:05:24 -0700999 (set -x; helm repo update >>$LOG 2>&1) >>$LOG 2>&1
1000 espin - $VERIFIED
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001001
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001002 # Create and k8s service account so that Helm can create pods
Test Userb5712372019-07-03 21:52:17 +00001003 bspin - "Create Tiller ServiceAccount"
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001004 (set -x; kubectl create serviceaccount --namespace kube-system tiller >>$LOG 2>&1) >>$LOG 2>&1
1005 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +00001006 bspin - "Create Tiller ClusterRoleBinding"
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001007 (set -x; kubectl create clusterrolebinding tiller-cluster-rule --clusterrole=cluster-admin --serviceaccount=kube-system:tiller >>$LOG 2>&1) >>$LOG 2>&1
1008 espin - $VERIFIED
Test Userb5712372019-07-03 21:52:17 +00001009 bspin - "Update Tiller Manifest"
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001010 (set -x; kubectl patch deploy --namespace kube-system tiller-deploy -p '{"spec":{"template":{"spec":{"serviceAccount":"tiller"}}}}' >>$LOG 2>&1) >>$LOG 2>&1
Test Userba1e7e72019-07-10 22:27:54 +00001011
1012 # HACK (sort-of) - part to, spin it back up
1013 (set -x; kubectl -n kube-system scale deploy tiller-deploy --replicas=1 >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001014 espin - $VERIFIED
1015else
1016 espin $VERIFIED
David Bainbridge46505fb2019-10-01 21:13:20 +00001017 if [ "$UPDATE_HELM_REPOS" == "yes" ]; then
1018 bspin - "Update Helm repository cache"
1019 (set -x; helm repo update >>$LOG 2>&1) >>$LOG 2>&1
1020 espin - $VERIFIED
1021 fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001022fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001023wait_for_pods - "kube-system" 1 "includes" -1 "Waiting for Tiller POD to start" "tiller-deploy-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001024if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001025 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001026fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001027
David Bainbridgee87067b2019-08-12 22:00:12 +00001028STIME=$(date +%s)
David Bainbridge0774b232019-08-02 06:37:19 +00001029bspin "Verify Helm values file: $NAME-values.yaml"
1030if [ ! -r "./$NAME-values.yaml" ]; then
Test Userba1e7e72019-07-10 22:27:54 +00001031 espin $NOT_VERIFIED
David Bainbridge0774b232019-08-02 06:37:19 +00001032 bspin - "Download Helm values file: $TYPE-values.yaml to $NAME-values.yaml $DOWNLOAD"
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001033 ERR_OUT=$(mktemp)
1034 (set -x; curl --fail -o ./$NAME-values.yaml -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$TYPE-values.yaml >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1035 if [ $? -ne 0 ]; then
1036 espin - $THEX
1037 echo -e "${RED}${BOLD}${ERROR}ERROR: $NAME-values.yaml${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1038 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
1039 rm -rf $ERR_OUT ./$NAME-values.yaml
1040 exit 1
1041 fi
1042 rm -rf $ERR_OUT
Test Userba1e7e72019-07-10 22:27:54 +00001043 espin - $VERIFIED
1044else
1045 espin $VERIFIED
1046fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001047if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001048 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001049fi
Test Userba1e7e72019-07-10 22:27:54 +00001050
David Bainbridge99ac7a22019-08-31 02:26:43 +00001051STIME=$(date +%s)
1052bspin "Verify or download chart specific values files $DOWNLOAD"
1053VALUES_FILES="monkey-values.yaml"
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001054ERR_OUT=$(mktemp)
David Bainbridge99ac7a22019-08-31 02:26:43 +00001055for i in $VALUES_FILES; do
1056 if [ ! -r ./$i ]; then
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001057 (set -x; curl --fail -o ./$i -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/$i >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1058 if [ $? -ne 0 ]; then
1059 espin $THEX
1060 echo -e "${RED}${BOLD}${ERROR}ERROR: $i${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1061 echo "ERROR: $i - $(cat $ERR_OUT)" >>$LOG
1062 rm -rf $ERR_OUT ./$i
1063 exit 1
1064 fi
1065 rm -rf $ERR_OUT
David Bainbridge99ac7a22019-08-31 02:26:43 +00001066 fi
1067done
1068espin $VERIFIED
1069if [ "$WITH_TIMINGS" == "yes" ]; then
1070 printtime $(expr $(date +%s) - $STIME)
1071fi
1072
1073if [ "$WITH_CHAOS" == "yes" ]; then
1074 bspin "Verify or clone kube-monkey helm chart $DOWNLOAD"
1075 if [ -r ./kube-monkey ]; then
1076 espin $VERIFIED
1077 else
1078 espin $NOT_VERIFIED
1079 bspin - "GIT clone kube-monkey"
1080 (set -x; git clone https://github.com/asobti/kube-monkey kube-monkey >>$LOG 2>&1) >>$LOG 2>&1
1081 espin - $VERIFIED
1082 fi
1083fi
1084
Test Userba1e7e72019-07-10 22:27:54 +00001085if [ "$JUST_K8S" == "yes" ]; then
1086 echo "Environment deployed, not deploying VOLTHA artifacts as requested. Good bye."
1087 echo ""
1088 echo "Please issue the following commands in your terminal to ensure that you" | tee -a $LOG
1089 echo "are accessing the correct Kubernetes/Kind cluster as well as have the " | tee -a $LOG
1090 echo "tools required by VOLTHA in your command path. " | tee -a $LOG
1091 echo "" | tee -a $LOG
1092 echo -en $BOLD
1093 if [ $DEPLOY_K8S == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +00001094 echo "export KUBECONFIG=\"\$(./bin/kind get kubeconfig-path --name=\"voltha-$NAME\")\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001095 fi
1096 echo "export PATH=$GOPATH/bin:\$PATH" | tee -a $LOG
1097 echo -en $NORMAL
1098 echo "" | tee -a $LOG
1099 echo "Thank you for choosing kind-voltha for you quick cluster needs." | tee -a $LOG
1100 exit 0
1101fi
1102
David Bainbridgee87067b2019-08-12 22:00:12 +00001103STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +00001104bspin "Verify ETCD Operator $OLD_KEY"
Test User7d866122019-07-09 17:52:35 +00001105if [ $(helm list --deployed --short --namespace voltha "^etcd-operator\$" | wc -l) -ne 1 ]; then
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001106 espin $NOT_VERIFIED
David Bainbridge90fd8e32019-08-21 23:32:47 +00001107 helm_install - voltha etcd-operator stable/etcd-operator latest "Install ETCD Operator"
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001108else
1109 espin $VERIFIED
1110fi
Test User01ed0642019-07-03 20:17:06 +00001111EXPECT=$(test "$TYPE" == "minimal" && echo "1" || echo "3")
David Bainbridge4f1b5562019-08-19 04:46:52 +00001112wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for ETCD Operator to start" "etcd-operator-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001113if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001114 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001115fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001116
David Bainbridgee87067b2019-08-12 22:00:12 +00001117STIME=$(date +%s)
David Bainbridgeb270c202019-07-26 01:44:42 +00001118if [ $WITH_ONOS == "yes" ]; then
1119 bspin "Verify ONOS installed $BIRD"
1120 if [ $(helm list --deployed --short --namespace default "^onos\$" | wc -l) -ne 1 ]; then
1121 espin $NOT_VERIFIED
Andrea Campanella6afcb082019-12-18 16:51:30 -08001122 EXTRA_HELM_FLAGS="$SET_TAG $EXTRA_HELM_FLAGS" helm_install - default onos onf/onos $ONOS_CHART_VERSION "Install ONOS"
David Bainbridgeb270c202019-07-26 01:44:42 +00001123 else
1124 espin $VERIFIED
1125 fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001126 wait_for_pods - "default" 1 "includes" -1 "Waiting for ONOS to start" "onos-.*"
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001127
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -08001128 if [ $WITH_PORT_FORWARDS == "yes" ]; then
1129 bspin - "Forward ONOS API port $FORWARD"
1130 kill_port_forward onos-ui
1131 port_forward default onos-ui $ONOS_API_PORT 8181
1132 espin - $VERIFIED
1133 bspin - "Forward ONOS SSH port $FORWARD"
1134 kill_port_forward onos-ssh
1135 port_forward default onos-ssh $ONOS_SSH_PORT 8101
1136 espin - $VERIFIED
1137 _ONOS_API_EP="127.0.0.1:$ONOS_API_PORT"
1138 else
1139 _ONOS_API_EP=$(get_service_ep default onos-ui)
1140 fi
David Bainbridged31d6122019-08-13 19:37:59 +00001141 bspin - "Verify or download ONOS configuration support files $DOWNLOAD"
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001142 ONOS_FILES="olt-onos-enableExtraneousRules.json onos-aaa.json \
David Bainbridge90fd8e32019-08-21 23:32:47 +00001143 onos-dhcpl2relay.json onos-kafka.json onos-sadis-sample.json"
David Bainbridged31d6122019-08-13 19:37:59 +00001144 (set -x; mkdir -p ./onos-files >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001145 ERR_OUT=$(mktemp)
David Bainbridge2b19e832019-08-16 02:40:53 +00001146 for i in $ONOS_FILES; do
David Bainbridged31d6122019-08-13 19:37:59 +00001147 if [ ! -r ./onos-files/$i ]; then
David K. Bainbridgea00736b2020-01-08 14:33:17 -08001148 (set -x; curl --fail -o ./onos-files/$i -sSL https://raw.githubusercontent.com/ciena/kind-voltha/$VK_RELEASE/onos-files/$i >>$LOG 2>$ERR_OUT) >>$LOG 2>&1
1149 if [ $? -ne 0 ]; then
1150 espin - $THEX
1151 echo -e "${RED}${BOLD}${ERROR}ERROR: $i${NORMAL}${RED} - $(cat $ERR_OUT)${NORMAL}"
1152 echo "ERROR: $(cat $ERR_OUT)" >>$LOG
1153 rm -rf $ERR_OUT ./onos-files/$i
1154 exit 1
1155 fi
1156 rm -rf $ERR_OUT
David Bainbridged31d6122019-08-13 19:37:59 +00001157 fi
1158 done
Test Userba1e7e72019-07-10 22:27:54 +00001159 espin - $VERIFIED
David Bainbridge27790d62019-08-13 22:43:19 +00001160
1161 if [ $INSTALL_ONOS_APPS == "yes" ]; then
1162 bspin - "Installing custom ONOS applications"
1163 if [ -x onos-files/onos-apps -a $(ls -1 onos-files/onos-apps/*.oar 2>/dev/null | wc -l) -gt 0 ]; then
1164 for OAR in $(ls -1 onos-files/onos-apps/*.oar); do
1165 sspin - "Installing custom ONOS applications - $OAR$CEOL"
David Bainbridge2b19e832019-08-16 02:40:53 +00001166 override_onos_app $OAR
David Bainbridge27790d62019-08-13 22:43:19 +00001167 done
1168 espin - "$VERIFIED Installing custom ONOS applications$CEOL"
1169 else
1170 espin - "$NOT_VERIFIED Installing custom ONOS applications - None Found"
1171 fi
1172 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001173
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001174 check_onos_app_active org.opencord.kafka
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001175 push_onos_config "file" "Push ONOS Kafka Configuration" "network/configuration/apps/org.opencord.kafka" "onos-files/onos-kafka.json"
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001176 check_onos_app_active org.opencord.dhcpl2relay
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001177 push_onos_config "file" "Push ONOS DHCP L2 Relay Configuration" "network/configuration/apps/org.opencord.dhcpl2relay" "onos-files/onos-dhcpl2relay.json"
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001178 check_onos_app_active org.opencord.olt
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001179 # FIXME use WITH_DHCP and WITH_EAPOL flags to configre OLT App
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001180 # Default value for "enableEapol" is true in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001181 if [ $WITH_EAPOL == "yes" ]; then
1182 push_onos_config "json" "Enable VOLTHA ONOS EAPOL provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableEapol":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001183 elif [ $WITH_EAPOL == "no" ]; then
1184 push_onos_config "json" "Disable VOLTHA ONOS EAPOL provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableEapol":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001185 fi
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001186 # Default value for "enableDhcpOnProvisioning" is false and for "enableDhcpV4" is true in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001187 if [ $WITH_DHCP == "yes" ]; then
1188 push_onos_config "json" "Enable VOLTHA ONOS DHCP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableDhcpOnProvisioning":true,"enableDhcpV4":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001189 elif [ $WITH_DHCP == "no" ]; then
1190 push_onos_config "json" "Disable VOLTHA ONOS DHCP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableDhcpOnProvisioning":false,"enableDhcpV4":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001191 fi
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001192 # Default value for "enableIgmpOnProvisioning" is false in OLT App
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001193 if [ $WITH_IGMP == "yes" ]; then
1194 push_onos_config "json" "Enable VOLTHA ONOS IGMP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableIgmpOnProvisioning":true}'
Hardik Windlassa7501fb2020-02-17 14:28:20 +00001195 elif [ $WITH_IGMP == "no" ]; then
1196 push_onos_config "json" "Disable VOLTHA ONOS IGMP provisioning" "configuration/org.opencord.olt.impl.OltFlowService" '{"enableIgmpOnProvisioning":false}'
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001197 fi
David K. Bainbridge484d80c2020-03-05 21:44:34 -08001198 if [ $ENABLE_ONOS_EXTRANEOUS_RULES == "yes" ]; then
1199 push_onos_config "file" "Enabling extraneous rules for ONOS" "configuration/org.onosproject.net.flow.impl.FlowRuleManager" "onos-files/olt-onos-enableExtraneousRules.json"
1200 fi
David Bainbridge2b19e832019-08-16 02:40:53 +00001201 if [ -f onos-files/onos-sadis.json ]; then
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001202 push_onos_config "file" "[optional] Push ONOS SADIS Configuration" "network/configuration/apps/org.opencord.sadis" "onos-files/onos-sadis.json"
David Bainbridge2b19e832019-08-16 02:40:53 +00001203 elif [ "$CONFIG_SADIS" == "yes" ]; then
David Bainbridge90fd8e32019-08-21 23:32:47 +00001204 SADIS_CFG=onos-files/onos-sadis-sample.json
Matteo Scandolo9a77a732020-01-09 14:24:12 -08001205 check_onos_app_active org.opencord.sadis
Matteo Scandolo78dfee02020-02-13 16:18:03 -08001206 push_onos_config "file" "[optional] Push ONOS SADIS Configuration" "network/configuration/apps/org.opencord.sadis" "$SADIS_CFG"
David Bainbridge2b19e832019-08-16 02:40:53 +00001207 fi
Test Userba1e7e72019-07-10 22:27:54 +00001208fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001209if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001210 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001211fi
Test Userba1e7e72019-07-10 22:27:54 +00001212
David Bainbridgee87067b2019-08-12 22:00:12 +00001213STIME=$(date +%s)
Test Userb5712372019-07-03 21:52:17 +00001214bspin "Verify VOLTHA installed $HIGH_VOLTAGE"
Test User7d866122019-07-09 17:52:35 +00001215if [ $(helm list --deployed --short --namespace voltha "^voltha\$" | wc -l) -ne 1 ]; then
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001216 espin $NOT_VERIFIED
David Bainbridge70c0ea82019-11-14 23:25:26 +00001217 if [ "$ONLY_ONE" == "yes" ]; then
1218 EXTRA_HELM_INSTALL_ARGS="--set therecanbeonlyone=true"=
1219 fi
David Bainbridge90fd8e32019-08-21 23:32:47 +00001220 helm_install - voltha voltha $VOLTHA_CHART $VOLTHA_CHART_VERSION "Install VOLTHA Core"
David Bainbridge70c0ea82019-11-14 23:25:26 +00001221 EXTRA_HELM_INSTALL_ARGS=
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001222else
1223 espin $VERIFIED
1224fi
Test Userba1e7e72019-07-10 22:27:54 +00001225
David Bainbridge90fd8e32019-08-21 23:32:47 +00001226VOLTHA="voltha-ofagent-.* \
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001227 ro-core.* \
1228 rw-core.* \
1229 voltha-api-server-.* \
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001230 voltha-etcd-cluster-.* \
1231 voltha-kafka-.* \
1232 voltha-zookeeper-.*"
David Bainbridge70c0ea82019-11-14 23:25:26 +00001233if [ "$ONLY_ONE" == "yes" ]; then
David Bainbridge1ba64f12019-12-18 00:40:13 +00001234 EXPECT=$(test "$TYPE" == "minimal" && echo "5" || echo "7")
David Bainbridge70c0ea82019-11-14 23:25:26 +00001235else
David Bainbridge1ba64f12019-12-18 00:40:13 +00001236 EXPECT=$(test "$TYPE" == "minimal" && echo "8" || echo "10")
David Bainbridge70c0ea82019-11-14 23:25:26 +00001237fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001238wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for VOLTHA Core to start" $VOLTHA
David Bainbridgee87067b2019-08-12 22:00:12 +00001239if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001240 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001241fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001242
David Bainbridge46505fb2019-10-01 21:13:20 +00001243if [ "$WITH_ADAPTERS" == "yes" ]; then
1244 STIME=$(date +%s)
1245 EXPECT=0
1246 echo -e "Verify Adapters $PLUG"
1247 if [ "$WITH_SIM_ADAPTERS" == "yes" ]; then
1248 bspin - "Verify Simulated Adapters installed"
1249 if [ $(helm list --deployed --short --namespace voltha "^sim\$" | wc -l) -ne 1 ]; then
1250 espin - $NOT_VERIFIED
1251 helm_install - voltha sim $VOLTHA_ADAPTER_SIM_CHART $VOLTHA_ADAPTER_SIM_CHART_VERSION "Install Simulated Adapters"
1252 else
1253 espin - $VERIFIED
1254 fi
1255 EXPECT=$(expr $EXPECT + 2)
1256 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001257
David Bainbridge46505fb2019-10-01 21:13:20 +00001258 if [ "$WITH_OPEN_ADAPTERS" == "yes" ]; then
1259 bspin - "Verify OpenOLT Adapter installed"
1260 if [ $(helm list --deployed --short --namespace voltha "^open-olt\$" | wc -l) -ne 1 ]; then
1261 espin - $NOT_VERIFIED
1262 helm_install - voltha open-olt $VOLTHA_ADAPTER_OPEN_OLT_CHART $VOLTHA_ADAPTER_OPEN_OLT_CHART_VERSION "Install OpenOLT Adapter"
1263 else
1264 espin - $VERIFIED
1265 fi
1266 bspin - "Verify OpenONU Adapter installed"
1267 if [ $(helm list --deployed --short --namespace voltha "^open-onu\$" | wc -l) -ne 1 ]; then
1268 espin - $NOT_VERIFIED
1269 helm_install - voltha open-onu $VOLTHA_ADAPTER_OPEN_ONU_CHART $VOLTHA_ADAPTER_OPEN_ONU_CHART_VERSION "Install OpenONU Adapter"
1270 else
1271 espin - $VERIFIED
1272 fi
1273 EXPECT=$(expr $EXPECT + 2)
1274 fi
Matteo Scandolo7ef6ba52019-10-04 09:20:37 -07001275
David Bainbridge46505fb2019-10-01 21:13:20 +00001276 ADAPTERS="adapter-.*"
1277 wait_for_pods - "voltha" $EXPECT "includes" -1 "Waiting for adapters to start" $ADAPTERS
1278 if [ "$WITH_TIMINGS" == "yes" ]; then
1279 printtime $(expr $(date +%s) - $STIME)
1280 fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001281fi
David K. Bainbridgeb7285432019-07-02 22:05:24 -07001282
Test User7d866122019-07-09 17:52:35 +00001283if [ $WITH_BBSIM == "yes" ]; then
David Bainbridgee87067b2019-08-12 22:00:12 +00001284 STIME=$(date +%s)
Test User7d866122019-07-09 17:52:35 +00001285 echo -e "Verify BBSIM $PLUG"
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001286 bspin - "Verify BBSIM Installed"
uottrembb16d3982020-02-28 08:34:36 +01001287 for instance in $(seq 0 $(($NUM_OF_BBSIM-1))); do
1288 if [ $instance -eq 0 ]; then
1289 instance_num=""
1290 else
1291 instance_num=$instance
1292 fi
1293 if [ $(helm list --deployed --short --namespace voltha "^bbsim${instance_num}\$" | wc -l) -ne 1 ]; then
1294 espin - $NOT_VERIFIED
1295 helm_install - voltha bbsim${instance_num} $VOLTHA_BBSIM_CHART $VOLTHA_BBSIM_CHART_VERSION "Install BBSIM${instance_num}"
1296 else
1297 espin - $VERIFIED
1298 fi
1299 done
1300 wait_for_pods - "voltha" $NUM_OF_BBSIM "includes" -1 "Waiting for BBSIM to start" "bbsim*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001301 if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001302 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001303 fi
Test User7d866122019-07-09 17:52:35 +00001304fi
1305
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001306if [ $WITH_RADIUS == "yes" ]; then
David Bainbridgee87067b2019-08-12 22:00:12 +00001307 STIME=$(date +%s)
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001308 echo -e "Verify RADIUS $LOCK"
1309 bspin - "Verify RADIUS Installed"
1310 if [ $(helm list --deployed --short --namespace voltha "^radius\$" | wc -l) -ne 1 ]; then
1311 espin - $NOT_VERIFIED
David Bainbridge90fd8e32019-08-21 23:32:47 +00001312 helm_install - voltha radius onf/freeradius latest "Install RADIUS"
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001313 else
1314 espin - $VERIFIED
1315 fi
David Bainbridge4f1b5562019-08-19 04:46:52 +00001316 wait_for_pods - "voltha" 1 "includes" -1 "Waiting for RADIUS to start" "radius-.*"
David Bainbridgee87067b2019-08-12 22:00:12 +00001317 if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridge712afb82019-08-14 19:55:58 +00001318 printtime $(expr $(date +%s) - $STIME)
David Bainbridgee87067b2019-08-12 22:00:12 +00001319 fi
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001320fi
1321
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -08001322if [ $WITH_PORT_FORWARDS == "yes" ]; then
1323 STIME=$(date +%s)
1324 bspin - "Forward VOLTHA API port $FORWARD"
1325 kill_port_forward voltha-api
1326 port_forward voltha voltha-api $VOLTHA_API_PORT 55555
1327 espin - $VERIFIED
1328 bspin - "Forward VOLTHA ETCD port $FORWARD"
1329 kill_port_forward voltha-etcd-cluster-client
1330 port_forward voltha voltha-etcd-cluster-client $VOLTHA_ETCD_PORT 2379
1331 espin - $VERIFIED
1332 bspin - "Forward VOLTHA Kafka port $FORWARD"
1333 kill_port_forward voltha-kafka
1334 port_forward voltha voltha-kafka $VOLTHA_KAFKA_PORT 9092
1335 espin - $VERIFIED
1336 if [ "$WITH_TIMINGS" == "yes" ]; then
1337 printtime $(expr $(date +%s) - $STIME)
1338 fi
David Bainbridgee87067b2019-08-12 22:00:12 +00001339fi
Test User3d7ad8e2019-07-03 06:15:44 +00001340
David Bainbridgeb270c202019-07-26 01:44:42 +00001341if [ $WITH_ONOS == "yes" -a $WITH_RADIUS == "yes" ]; then
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001342 bspin "Configure ONOS RADIUS Connection $GEAR"
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -08001343 (set -x; cat onos-files/onos-aaa.json | sed -e "s/:RADIUS_IP:/$(kubectl -n voltha get service/radius -o jsonpath={.spec.clusterIP})/g" | curl --fail -sSL --user karaf:karaf -X POST http://$_ONOS_API_EP/onos/v1/network/configuration/apps/org.opencord.aaa -H Content-type:application/json -d@- >>$LOG 2>&1) >>$LOG 2>&1
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001344 espin $VERIFIED
1345fi
1346
David Bainbridge99ac7a22019-08-31 02:26:43 +00001347if [ "$WITH_CHAOS" == "yes" ]; then
1348 STIME=$(date +%s)
1349 echo -e "Verify kube-monkey $LOCK"
1350 bspin - "Verify kube-monkey Installed"
1351 if [ $(helm list --deployed --short --namespace kube-monkey "^monkey\$" | wc -l) -ne 1 ]; then
1352 espin - $NOT_VERIFIED
1353 helm_install - kube-monkey monkey ./kube-monkey/helm/kubemonkey latest "Install Chaos Monkey"
1354 else
1355 espin - $VERIFIED
1356 fi
1357 wait_for_pods - "kube-monkey" 1 "includes" -1 "Waiting for Chaos to start" "monkey-.*"
1358 if [ "$WITH_TIMINGS" == "yes" ]; then
1359 printtime $(expr $(date +%s) - $STIME)
1360 fi
1361fi
1362
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001363bspin "Create voltctl configuration file"
Test User3d7ad8e2019-07-03 06:15:44 +00001364(set -x; mkdir -p $HOME/.volt >>$LOG 2>&1) >>$LOG 2>&1
David K. Bainbridge4a06a4a2020-03-02 14:15:23 -08001365if [ $WITH_PORT_FORWARDS == "yes" ]; then
1366 (set -x; voltctl -a v3 -k localhost:$VOLTHA_KAFKA_PORT -s localhost:$VOLTHA_API_PORT config > $HOME/.volt/config-$NAME 2>>$LOG) >>$LOG 2>&1
1367else
1368 (set -x; voltctl -a v3 -k $(get_service_ep voltha voltha-kafka) -s $(get_service_ep voltha voltha-api) config > $HOME/.volt/config-$NAME 2>>$LOG) >>$LOG 2>&1
1369fi
David Bainbridge5b7b96b2019-07-25 20:29:13 +00001370espin $VERIFIED
Test User08ebbd92019-07-03 17:15:39 +00001371
David Bainbridge0774b232019-08-02 06:37:19 +00001372if [ ! -f "$NAME-env.sh" ]; then
1373 touch $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001374fi
1375
David Bainbridge596f30d2019-07-30 17:07:59 +00001376for O in $ALL_OPTIONS; do
1377 VAL=$(eval echo \$$O)
David Bainbridge0774b232019-08-02 06:37:19 +00001378 if [ ! -z "$VAL" -a $(grep -c "^export $O=" $NAME-env.sh) -eq 0 ]; then
1379 echo "export $O=\"$(eval echo \$$O)\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001380 fi
1381done
1382
David Bainbridge0774b232019-08-02 06:37:19 +00001383if [ $DEPLOY_K8S == "yes" -a $(grep -c "^export KUBECONFIG=" $NAME-env.sh) -eq 0 ]; then
1384 echo "export KUBECONFIG=\"$(./bin/kind get kubeconfig-path --name=voltha-$NAME)\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001385fi
1386
David Bainbridge0774b232019-08-02 06:37:19 +00001387if [ $(grep -c "^export VOLTCONFIG=" $NAME-env.sh) -eq 0 ]; then
1388 echo "export VOLTCONFIG=\"$HOME/.volt/config-$NAME\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001389fi
1390
David Bainbridge0774b232019-08-02 06:37:19 +00001391if [ $(grep -c "^export PATH=" $NAME-env.sh) -eq 0 ]; then
1392 echo "export PATH=\"$GOPATH/bin:\$PATH\"" >> $NAME-env.sh
David Bainbridgeb07fdf72019-07-29 22:51:40 +00001393fi
1394
Test User7d866122019-07-09 17:52:35 +00001395echo ""
Test User08ebbd92019-07-03 17:15:39 +00001396echo "Please issue the following commands in your terminal to ensure that you" | tee -a $LOG
1397echo "are accessing the correct Kubernetes/Kind cluster as well as have the " | tee -a $LOG
1398echo "tools required by VOLTHA in your command path. " | tee -a $LOG
1399echo "" | tee -a $LOG
Test User7d866122019-07-09 17:52:35 +00001400echo -en $BOLD
Test Userba1e7e72019-07-10 22:27:54 +00001401if [ $DEPLOY_K8S == "yes" ]; then
David Bainbridge0774b232019-08-02 06:37:19 +00001402 echo "export KUBECONFIG=\"\$(./bin/kind get kubeconfig-path --name=\"voltha-$NAME\")\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001403fi
David Bainbridge0774b232019-08-02 06:37:19 +00001404echo "export VOLTCONFIG=\"$HOME/.volt/config-$NAME\"" | tee -a $LOG
Test Userba1e7e72019-07-10 22:27:54 +00001405echo "export PATH=$GOPATH/bin:\$PATH" | tee -a $LOG
Test User7d866122019-07-09 17:52:35 +00001406echo -en $NORMAL
Test User08ebbd92019-07-03 17:15:39 +00001407echo "" | tee -a $LOG
1408echo "Thank you for choosing kind-voltha for you quick cluster needs." | tee -a $LOG
1409
David Bainbridge712afb82019-08-14 19:55:58 +00001410if [ "$WITH_TIMINGS" == "yes" ]; then
David Bainbridgef858a022019-08-14 21:25:11 +00001411 echo -e "$CLOCK ${BOLD}TOTAL: $(duration $(expr $(date +%s) - $TOTAL_START_TIME))${NORMAL}"
David Bainbridge712afb82019-08-14 19:55:58 +00001412fi